﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Schedules;
using Infragistics.Controls.Schedules.EWS;
using Infragistics.Collections;

namespace xamSheduleExchangeDataConnector
{
    /// <summary>
    /// Interaction logic for xamShedule.xaml
    /// </summary>
    public partial class xamShedule : UserControl
    {

        public xamShedule()
        {
            InitializeComponent();

            System.Net.ServicePointManager.ServerCertificateValidationCallback += new System.Net.Security.RemoteCertificateValidationCallback(ValidateRemoteCertificate);

            ExchangeConnector.UseDefaultCredentials = false;
            List<ExchangeUser> users = new List<ExchangeUser>();
            users.Add(new ExchangeUser("USERNAME", "PASSWORD", "DOMAIN"));
            ExchangeConnector.Users = users;
            ExchangeConnector.ServerConnectionSettings = new ExchangeServerConnectionSettings();
            ExchangeConnector.ServerConnectionSettings.RequestedServerVersion = ExchangeVersion.AutoDetect;
            ExchangeConnector.ServerConnectionSettings.Url = new Uri("SERVERADDRESS");
            ExchangeConnector.Connect();
            ScheduleDataManager.CurrentUserId = "DOMAIN\\USERNAME";
          
        }

        void ResourceItems_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            ResourceCollection TheseResources = (ResourceCollection)sender;
            if (TheseResources.Count() < 1)
                return;

            ScheduleDataManager.CalendarGroups.Clear();
            CalendarGroup calGroup = new CalendarGroup();

            foreach (Resource res in TheseResources)
            {
                foreach (ResourceCalendar cal in res.Calendars)
                {
                    calGroup.Calendars.Add(cal);
                }
            }
            ScheduleDataManager.CalendarGroups.Add(calGroup);

            Infragistics.DateRange range = new Infragistics.DateRange(new DateTime(2015, 10, 19), new DateTime(2015, 10, 25));
            foreach (Resource res in TheseResources)
            {
                foreach (ResourceCalendar cal in res.Calendars)
                {
                    ActivityQuery actQuery = new ActivityQuery(ActivityTypes.All, range, cal);
                    ActivityQueryResult myq = ScheduleDataManager.GetActivities(actQuery);
                    ReadOnlyNotifyCollection<ActivityBase> activities = myq.Activities;
                }
            }
        }

        private bool ValidateRemoteCertificate(object sender, System.Security.Cryptography.X509Certificates.X509Certificate certificate, System.Security.Cryptography.X509Certificates.X509Chain chain, System.Net.Security.SslPolicyErrors policyErrors)
        {
            return true;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            ExchangeConnector.ResourceItems.CollectionChanged += new System.Collections.Specialized.NotifyCollectionChangedEventHandler(ResourceItems_CollectionChanged);
        }
    }
}
